from Products.WhoOnline import tools_globals, WhoOnline
from Products.WhoOnline.WhoOnline import manage_addWhoOnline
#import WhoOnline

#tools_globals = globals()


from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName, ToolInit
from Acquisition import aq_base
from cStringIO import StringIO
import string
import sys
	
typestool = skinstool = portal_url = out = None

slots = (('left_slots','here/who_online_slot/macros/whoOnlineBox'),)

def install_tool(installed_product, installed_skin):
	#tool
	portal = portal_url.getPortalObject()
	try:	
		product = manage_addWhoOnline(portal,id=installed_product)
		out.write("Added '%s' product to portal's root\n" % installed_product)
	except Exception, details:
		out.write("Unable to add '%s' product to portal's root: %s %s\n" % (installed_product,str(Exception),str(details)))	
	except:
		out.write("Unable to add '%s': %s, %s\n" %(installed_product, sys.exc_info()[0], sys.exc_info()[1]))	
	
	# skins
	if installed_skin not in skinstool.objectIds():
		try:
			addDirectoryViews(skinstool, 'skins', tools_globals)
			out.write("Added '%s' directory view to portal_skins\n" % installed_skin)
		except:
			out.write("Unable to add '%s' directory view to portal_skins: %s, %s\n" % (installed_skin,sys.exc_info()[0], sys.exc_info()[1]))
	
	skins = skinstool.getSkinSelections()
	for skin in skins:
		path = skinstool.getSkinPath(skin)
		path = map(string.strip, string.split(path,','))
		if installed_skin not in path:
			try: 
				path.insert(path.index('content'), installed_skin)
			except ValueError:
				path.append(installed_skin)
				
			path = string.join(path, ', ')
			skinstool.addSkinSelection(skin, path)
			out.write("Added '%s' to %s skin\n" % (installed_skin, skin))
		else:
			out.write("Skipping %s skin, '%s' is already set up\n" % (skin, installed_skin))	
	for slot in slots:
		s = slot[0]
		if hasattr(portal,s):
			if slot[1] not in portal.right_slots:
				new_slot = getattr(portal,s)+[slot[1]]
				setattr(portal,s,new_slot)
				out.write("Added %s slot to %s\n" % (slot[1],s))
			else:
				out.write("Skipping slot %s to %s :already set up\n" % (slot[1],s))
def install(self):
	g = globals()
	g['out'] = StringIO()
	g['skinstool'] = getToolByName(self, 'portal_skins')
	g['portal_url'] = getToolByName(self, 'portal_url')
		
	install_tool('who_online', 'zpt_who_online')
	return out.getvalue()

